Skip to main content
GET
/
subscriptions
/
payments
/
{payment_id}
/
controlled
/
notifications
/
{notification_id}
Fetch Controlled Notification
curl --request GET \
  --url https://sandbox.cashfree.com/pg/subscriptions/payments/{payment_id}/controlled/notifications/{notification_id} \
  --header 'x-api-version: <x-api-version>' \
  --header 'x-client-id: <api-key>' \
  --header 'x-client-secret: <api-key>'
{
  "cf_notification_id": "3333",
  "cf_order_id": "123456",
  "cf_payment_id": "123456",
  "cf_subscription_id": "7891011",
  "cf_txn_id": "123456",
  "notification_failure_details": {
    "failure_reason": "",
    "failure_error_code": "",
    "failure_sub_error_code": ""
  },
  "notification_attempted_time": "2025-06-01T22:14:59+05:30",
  "notification_completed_time": "2025-06-01T22:14:59+05:30",
  "notification_id": "basePay123-pdn1",
  "notification_initiated_time": "2025-06-01T22:14:58+05:30",
  "notification_status": "INITIALIZED",
  "payment_amount": 10,
  "payment_id": "basePay123",
  "payment_remarks": "remarks",
  "payment_status": "INITIALIZED",
  "subscription_id": "abcd"
}

Documentation Index

Fetch the complete documentation index at: https://www.cashfree.com/docs/llms.txt

Use this file to discover all available pages before exploring further.

This API supports UPI mandates only. eNACH mandates are not supported. Card support is planned for a future release.

Authorizations

x-client-id
string
header
required

Client app ID. You can find your app id in the Merchant Dashboard.

x-client-secret
string
header
required

Client secret key. You can find your secret key in the Merchant Dashboard.

Headers

x-api-version
string
default:2025-01-01
required

API version to be used.

x-request-id
string

Request ID for the API call. Can be used to resolve tech issues. Communicate this in your tech related queries to Cashfree.

x-idempotency-key
string<UUID>

An idempotency key is a unique identifier you include with your API call. If the request fails or times out, you can safely retry it using the same key to avoid duplicate actions.

Path Parameters

payment_id
string
required

Provide the Payment ID using which the payment was created.

notification_id
string
required

Provide the Notification ID for which the details have to be fetched.

Response

Success response for fetching a controlled payment notification.

Response returned when fetching a controlled payment notification.

cf_notification_id
string

Cashfree-generated identifier for the controlled notification.

cf_order_id
string

Cashfree subscription payment order ID.

cf_payment_id
string

Cashfree subscription payment reference number.

cf_subscription_id
string

Cashfree subscription reference number.

cf_txn_id
string

Cashfree subscription payment transaction ID.

notification_attempted_time
string<ISO8601>

The timestamp when the controlled notification was attempted. Timestamps are in IST.

Example:

"2025-06-01T22:14:59+05:30"

notification_completed_time
string<ISO8601>

The timestamp when the controlled notification was completed. Timestamps are in IST.

Example:

"2025-06-01T22:14:59+05:30"

notification_failure_details
ControlledAttemptFailureDetails · object

Details of the failure associated with a controlled notification or execution attempt.

notification_id
string

The unique merchant-provided identifier for the controlled notification.

notification_initiated_time
string<ISO8601>

The timestamp when the controlled notification was initiated. Timestamps are in IST.

Example:

"2025-06-01T22:14:58+05:30"

notification_status
string

Status of the controlled payment notification.

payment_amount
number<float64>

Amount associated with the controlled payment notification.

payment_id
string

Base Payment ID associated with the controlled payment notification.

payment_remarks
string

Payment remarks for the controlled payment notification.

payment_status
string

Current status of the parent payment entity.

subscription_id
string

Subscription ID associated with the controlled payment notification.